﻿using System;
using System.Collections.Generic;

namespace HeuristicLab.EvolutionTracking {
  public interface IGenealogyGraphNode : IVertex, IComparable<IGenealogyGraphNode> {
    IEnumerable<IGenealogyGraphNode> Ancestors();
    IEnumerable<IGenealogyGraphNode> Descendants();

    new List<IGenealogyGraphArc> InArcs { get; }
    new List<IGenealogyGraphArc> OutArcs { get; }

    double Rank { get; set; }
    double Quality { get; set; }
    bool IsElite { get; set; }
  }

  public interface IGenealogyGraphNode<T> : IGenealogyGraphNode, IVertex<T> { }

}